﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;


namespace devP2P
{
    class P2P
    {
        // enable preferred one for your environment - x64 or x86
//        const String DEVP2P_DLL = "..\\..\\..\\..\\bin\\Windows_x86_dll\\devP2P.DLL";
        public const String DEVP2P_DLL = "..\\..\\..\\..\\bin\\Windows_x64_dll\\devP2P.DLL";

        public enum Protocols { ProtoTCP = 1, ProtoUDP = 2, ProtoBoth = 3 };
        public enum Encryptions { EncNone = 0, EncAES128 = 1, EncAES192 = 2, EncAES256 = 3 };
        public enum States { StateStopped = 0, StateStarted = 1, StateSearching = 2, StateSearchDone = 3, StateLinking = 4, StateConnected = 5, StateDisconnecting = 6, StateDisconnected = 7 };
        public enum ForwardTypes { TCPLocalListen = 0, TCPRemoteListen = 1, UDPLocalListen = 2, UDPRemoteListen = 3, TCPSocksProxy = 4, TCPHttpProxy = 5 };
        public enum ConnectionTypes { ConnectionUnspecified = 0, ConnectionTCPDirect = 1, ConnectionUDPDirect = 2, ConnectionTCPRelayed = 3 };

        // create destroy
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Create", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr Create();
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Destroy", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Destroy(IntPtr Handle);

        // properties
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetLicenseKey", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLicenseKey(IntPtr Handle, string Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetUDPPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetUDPPort(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetUDPPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetUDPPort(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetTCPPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetTCPPort(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetTCPPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetTCPPort(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetMediatorPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetMediatorPort(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetMediatorPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetMediatorPort(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetVersion", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetVersion(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetMyName", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetMyName(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetMyName", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetMyName(IntPtr Handle, string Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetPeerName", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetPeerName(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetPeerName", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetPeerName(IntPtr Handle, string Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetMediatorAddress", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetMediatorAddress(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetMediatorAddress", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetMediatorAddress(IntPtr Handle, string Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetRelayLicense", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetRelayLicense(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetRelayLicense", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetRelayLicense(IntPtr Handle, string Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern object GetTag(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetTag(IntPtr Handle, object Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetState", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetState(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetConnectionType", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetConnectionType(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetMediatorRetryDelay", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetMediatorRetryDelay(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetMediatorRetryDelay", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetMediatorRetryDelay(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetMediatorRetryCount", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetMediatorRetryCount(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetMediatorRetryCount", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetMediatorRetryCount(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetLinkingRetryDelay", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetLinkingRetryDelay(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetLinkingRetryDelay", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLinkingRetryDelay(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetLinkingRetryCount", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetLinkingRetryCount(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetLinkingRetryCount", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLinkingRetryCount(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetLinkingRelayDelay", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetLinkingRelayDelay(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetLinkingRelayDelay", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLinkingRelayDelay(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetConnectionTimeout", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetConnectionTimeout(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetConnectionTimeout", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetConnectionTimeout(IntPtr Handle, int Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetPeerAdapterIP", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetPeerAdapterIP(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetPeerAdapterMAC", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetPeerAdapterMAC(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetVPNadapter", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int SetVPNadapter(IntPtr Handle, string Value);



        // methods
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Start", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Start(IntPtr Handle, int protocol);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Stop", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Stop(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Disconnect", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Disconnect(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Search", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Search(IntPtr Handle, string customdata);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Link", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Link(IntPtr Handle, string peerXML);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Ping", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Ping(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SetPassword", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetPassword(IntPtr Handle, int encryption, string password);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SendText", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int SendText(IntPtr Handle, int chanid, string text, bool reliable);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SendData", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int SendData(IntPtr Handle, int chanid, string data, int len, bool reliable);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_SendFile", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int SendFile(IntPtr Handle, int chanid, string localfilename, string remotefilename, bool doresume);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_TestBandwidth", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int TestBandwidth(IntPtr Handle, int chanid, long size);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_PrintStats", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void PrintStats(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_GetForward", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr GetForward(IntPtr Handle, int index);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_StartForward", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int StartForward(IntPtr Handle, int index);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_StopForward", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int StopForward(IntPtr Handle, int index);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_BandwidthReset", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void BandwidthReset(IntPtr Handle, int chanid);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_Bandwidth", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern float Bandwidth(IntPtr Handle, int chanid);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_StateText", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void StateText(IntPtr Handle, int state, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_ErrorText", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void ErrorText(IntPtr Handle, int errorno, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);

        // P2PForward
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_GetForwardType", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Forward_GetForwardType(IntPtr ForwardHandle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_SetForwardType", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_SetForwardType(IntPtr ForwardHandle, int value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_GetLocalAddress", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_GetLocalAddress(IntPtr ForwardHandle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_SetLocalAddress", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_SetLocalAddress(IntPtr ForwardHandle, string value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_GetLocalPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Forward_GetLocalPort(IntPtr ForwardHandle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_SetLocalPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_SetLocalPort(IntPtr ForwardHandle, int value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_GetRemoteAddress", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_GetRemoteAddress(IntPtr ForwardHandle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_SetRemoteAddress", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_SetRemoteAddress(IntPtr ForwardHandle, string value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_GetRemotePort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Forward_GetRemotePort(IntPtr ForwardHandle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_SetRemotePort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_SetRemotePort(IntPtr ForwardHandle, int value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_IsOpen", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern bool Forward_IsOpen(IntPtr ForwardHandle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_DisconnectUser", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_DisconnectUser(IntPtr ForwardHandle, IntPtr UserHandle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForwardUser_Disconnect", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void ForwardUser_Disconnect(IntPtr UserHandle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForwardUser_GetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern object ForwardUser_GetTag(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForwardUser_SetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void ForwardUser_SetTag(IntPtr Handle, object Value);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_GetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern object Forward_GetTag(IntPtr Handle);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2PForward_SetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Forward_SetTag(IntPtr Handle, object Value);

        // events
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void StateChangeEvent(IntPtr Handle, int state);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void NewUPNPMappingEvent(IntPtr Handle, string ExtAddress, string IntAddress, int TCPPort, int UDPPort);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void SearchStartEvent(IntPtr Handle, int binds);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void SearchDoneEvent(IntPtr Handle, string peerName, string peerXML, string customData, int errorno);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void LinkDoneEvent(IntPtr Handle, string address, int port, int errorno);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void StoppedEvent(IntPtr Handle, int errorno);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void TextReceivedEvent(IntPtr Handle, int chanid, string text);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void DataReceivedEvent(IntPtr Handle, int chanid, string data, int len);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate bool FileSendEvent(IntPtr Handle, int chanid, string filename, Int64 size);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate bool FileReceiveEvent(IntPtr Handle, int chanid, string filename, Int64 size);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void FileProgressEvent(IntPtr Handle, int chanid, Int64 position, Int64 size);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void FileDoneEvent(IntPtr Handle, int chanid, int errorno);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate bool ForwardOpenEvent(IntPtr Handle, int forwardid, int forwardtype, string localaddress, int localport, string remoteaddress, int remoteport);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void ForwardCloseEvent(IntPtr Handle, int forwardid, int errorno);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate bool UserConnectedEvent(IntPtr Handle, int forwardid, int chanid, IntPtr userhandle);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void UserDisconnectedEvent(IntPtr Handle, int forwardid, int chanid, IntPtr userhandle, int errorno);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void PingEvent(IntPtr Handle);

        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterStateChangeEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterStateChangeEvent (IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] StateChangeEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterNewUPNPMappingEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterNewUPNPMappingEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] NewUPNPMappingEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterSearchStartEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterSearchStartEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] SearchStartEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterSearchDoneEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterSearchDoneEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] SearchDoneEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterLinkDoneEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterLinkDoneEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] LinkDoneEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterStoppedEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterStoppedEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] StoppedEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterTextReceivedEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterTextReceivedEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] TextReceivedEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterDataReceivedEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterDataReceivedEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] DataReceivedEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterFileSendEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterFileSendEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] FileSendEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterFileReceiveEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterFileReceiveEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] FileReceiveEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterFileProgressEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterFileProgressEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] FileProgressEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterFileDoneEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterFileDoneEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] FileDoneEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterForwardOpenEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterForwardOpenEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] ForwardOpenEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterForwardCloseEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterForwardCloseEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] ForwardCloseEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterUserConnectedEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterUserConnectedEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] UserConnectedEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterUserDisconnectedEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterUserDisconnectedEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] UserDisconnectedEvent func);
        [DllImport(DEVP2P_DLL, EntryPoint = "P2P_RegisterPingEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterPingEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] PingEvent func);
    }

    class VPN
    {
        // create destroy
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_Create", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr Create();
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_Destroy", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void Destroy(IntPtr Handle);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_SetLicenseKey", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetLicenseKey(IntPtr Handle, string Value);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_GetMediatorPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetMediatorPort(IntPtr Handle);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_SetMediatorPort", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetMediatorPort(IntPtr Handle, int Value);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_GetVersion", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetVersion(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_GetMyName", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetMyName(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_SetMyName", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetMyName(IntPtr Handle, string Value);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_GetMediatorAddress", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetMediatorAddress(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_SetMediatorAddress", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetMediatorAddress(IntPtr Handle, string Value);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_GetRelayLicense", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetRelayLicense(IntPtr Handle, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_SetRelayLicense", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetRelayLicense(IntPtr Handle, string Value);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_GetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern object GetTag(IntPtr Handle);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_SetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetTag(IntPtr Handle, object Value);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_GetState", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int GetState(IntPtr Handle);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_StateText", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void StateText(IntPtr Handle, int state, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_ErrorText", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void ErrorText(IntPtr Handle, int errorno, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);

        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_Start", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Start(IntPtr Handle, int protocol);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_Stop", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Stop(IntPtr Handle);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_Search", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Search(IntPtr Handle, string peerNames, String password, bool forever);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_SetAdapter", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int SetAdapter(IntPtr Handle, int adapterIndex);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void StateChangeEvent(IntPtr Handle, int state);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate bool PeerConnectingEvent(IntPtr Handle, IntPtr p2pHandle, string peerName, string peerAddrs);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void PeerConnectedEvent(IntPtr Handle, IntPtr p2pHandle, string address, int port);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void PeerDisconnectedEvent(IntPtr Handle, IntPtr p2pHandle, int ErrorNo);


        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_RegisterStateChangeEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterStateChangeEvent (IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] StateChangeEvent func);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_RegisterPeerConnectingEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterPeerConnectingEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] PeerConnectingEvent func);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_RegisterPeerConnectedEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterPeerConnectedEvent(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] PeerConnectedEvent func);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPN_RegisterPeerDisconnectedEvent", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RegisterPeerDisconnected(IntPtr Handle, [MarshalAs(UnmanagedType.FunctionPtr)] PeerDisconnectedEvent func);
    }


    class VPNAdapter
    {
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_Count", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int Count();
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_GetName", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetName(int adapterIndex, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_GetDriverName", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetDriverName(int adapterIndex, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_GetGuid", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetGuid(int adapterIndex, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_GetLocalIP", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetLocalIP(int adapterIndex, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_GetLocalNetmask", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetLocalNetmask(int adapterIndex, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_GetLocalMAC", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void GetLocalMAC(int adapterIndex, [MarshalAs(UnmanagedType.LPStr)] StringBuilder buffer);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_GetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern object GetTag(int adapterIndex);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_SetTag", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SetTag(int adapterIndex, object Value);
        [DllImport(P2P.DEVP2P_DLL, EntryPoint = "VPNAdapter_SetIP", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern int SetIP(int adapterIndex, String ipaddress, String netmask);
    }
}
