#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef _WIN32
#include <windows.h>
#include <conio.h>
#pragma warning(disable: 4996)
#ifdef _WIN64
#pragma comment(lib, "../../../bin/Windows_x64_lib/devP2P.lib")
#else
#pragma comment(lib, "../../../bin/Windows_x86_lib/devP2P.lib")
#endif
#pragma comment(lib, "wsock32.lib")
#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "iphlpapi.lib")

#if (defined (_MSC_VER) && defined (_DEBUG))
//HACK: allow the use of mixed debug/non-debug code
extern "C" {
	_CRTIMP void __cdecl _invalid_parameter_noinfo(void) {  }
}
#endif

#else
#define getch getchar
#endif
#include "../../../inc/p2p.h"

void p2p_StateChange(devP2Plib::CP2P *p2p, devP2Plib::States state)
{
	printf("%s] State changed to %s\r\n", p2p->MyName, p2p->StateText(state));
}
void p2p_NewUPNPMapping(devP2Plib::CP2P *p2p, char *ExtAddress, char *IntAddress, int TCPPort, int UDPPort)
{
	if (TCPPort) printf("%s] New TCP mapping: %s->%s (%d)\r\n", p2p->MyName, ExtAddress, IntAddress, TCPPort);
	if (UDPPort) printf("%s] New UDP mapping: %s->%s (%d)\r\n", p2p->MyName, ExtAddress, IntAddress, UDPPort);
}
void p2p_SearchStart(devP2Plib::CP2P *p2p, char *binds)
{
	printf("%s] started searching for %s at %s (%d)\r\n", p2p->MyName, p2p->PeerName, p2p->MediatorAddress, p2p->MediatorPort);
}
void p2p_SearchDone(devP2Plib::CP2P *p2p, char *peerName, char *peerAddress, char *customData, devP2Plib::Errors error)
{
	printf("%s] Search finished with error %d %s\r\n", peerName, error, p2p->ErrorText(error));
	if (!error)
		p2p->Link(peerAddress);
}
void p2p_LinkDone(devP2Plib::CP2P *p2p, char *address, int port, devP2Plib::Errors error)
{
	if (!error)	
		printf("%s] Connected to %s (%d)\r\n", p2p->MyName, address, port);
	else
		printf("%s] Connection failed with error %s (%d)\r\n", p2p->MyName, p2p->ErrorText(error), error);
}
void p2p_Stopped(devP2Plib::CP2P *p2p, devP2Plib::Errors error)
{
	printf("%s] Stopped, error %s\r\n", p2p->MyName, p2p->ErrorText(error));
}

void p2p_TextReceived(devP2Plib::CP2P *p2p, int chanid, char *text)
{
	printf("%s] Received text %s\r\n", p2p->MyName, text);
}

void p2p_DataReceived(devP2Plib::CP2P *p2p, int chanid, char *data, int len)
{
	printf("%s] Received %d bytes of data\r\n", p2p->MyName, len);
}
bool p2p_FileSend(devP2Plib::CP2P *p2p, int chanid, char *filename, int64 size)
{
	printf("%s] Sending file %s (%ld)\r\n", p2p->MyName, filename, (long)size);
	return true;
}
bool p2p_FileReceive(devP2Plib::CP2P *p2p, int chanid, char *filename, int64 size)
{
	printf("%s] Receiving file %s (%ld)\r\n", p2p->MyName, filename, (long)size);
	return true;
}
void p2p_FileProgress(devP2Plib::CP2P *p2p, int chanid, int64 position, int64 size)
{
	printf("%s] Progress %ld/%ld (%d%%) bandwidth=%5.2f MB/sec\r\n", p2p->MyName, (long)position, (long)size, (int)((position*100)/size), p2p->Bandwidth(chanid));
}
void p2p_FileDone(devP2Plib::CP2P *p2p, int chanid, devP2Plib::Errors error)
{
	printf("%s] Transfer completed with error %d %s\r\n", p2p->MyName, error, p2p->ErrorText(error));
}
bool p2p_ForwardOpen(devP2Plib::CP2P *p2p, int forwid, devP2Plib::ForwardTypes forwardtype, char *localaddress, int localport, char *remoteaddress, int remoteport)
{
	const char *t = "Unknown";
	switch (forwardtype)
	{
	case devP2Plib::TCPLocalListen:		t="TCPLocalListen";break;
	case devP2Plib::TCPRemoteListen:	t="TCPRemoteListen";break;
	case devP2Plib::UDPLocalListen:		t="UDPLocalListen";break;
	case devP2Plib::UDPRemoteListen:	t="UDPRemoteListen";break;
	case devP2Plib::TCPSocksProxy:		t="TCPSocksProxy";break;
	case devP2Plib::TCPHttpProxy:		t="TCPHttpProxy";break;
	}
	printf("%s] Forward %s open from %s (%d) ==> %s (%d)\r\n", p2p->MyName, t, localaddress, localport, remoteaddress, remoteport);
	return true;
}
void p2p_ForwardClose(devP2Plib::CP2P *p2p, int forwid, devP2Plib::Errors error)
{
	printf("%s] Forward close with error %d %s\r\n", p2p->MyName, error, p2p->ErrorText(error));
}
bool p2p_UserConnected(devP2Plib::CP2P *p2p, int forwid, int chanid, devP2Plib::CP2PForwardUser *user)
{
	printf("%s] User connected\r\n", p2p->MyName);
	return true;
}
void p2p_UserDisconnected(devP2Plib::CP2P *p2p, int forwid, int chanid, devP2Plib::CP2PForwardUser *user, devP2Plib::Errors error)
{
	printf("%s] User disconnected with error %d %s\r\n", p2p->MyName, error, p2p->ErrorText(error));
}

void Usage(void)
{
	printf("SimpleP2P version 0.9, WeOnlyDo Software (2014)\r\n");
	printf("--\r\n");
	printf("Usage: SimpleP2P MyName PeerName [options]\r\n");
	printf("  MyName and PeerName must be provided!\r\n");
	printf("  Options can be:\r\n");
	printf("    -password <desired.password>\r\n");
	printf("    -mediatorip <ip.address.of.mediator>\r\n");
	printf("    -mediatorport <port.of.mediator>\r\n");
	printf("    -udp [bind port] use udp [and bind to specific port]\r\n");
	printf("    -tcp [bind port] use tcp [and bind to specific port]\r\n");
	printf("    -link <ipaddress:port> connect tcp to ipaddress:port\r\n");
	printf("    -relay <ipaddress:port> add relay with ipaddress:port\r\n");
	printf("    -send <filename> send file after connection is made\r\n");
#if !defined(__CYGWIN__)
	printf("    -listadapters lists all VPN adapters\r\n");
	printf("    -useadapter <name> uses adapter with id for packet forwarding\r\n");
	printf("    -setip <ip.ad.re.ss> set IP for the adapter\r\n");
	printf("    -setnemask <ne.tm.as.k> set netmask for the adapter\r\n");
#endif
	printf("\r\n");
}

#ifndef _WIN32
int Sleep(unsigned long milisec);
#define _stricmp strcasecmp
#endif


int main(int argc, char **argv)
{
#ifdef _WIN32
	WSADATA m_wsadata;
	WSAStartup(MAKEWORD(2, 0), &m_wsadata);
#endif

	devP2Plib::libInit();
	devP2Plib::upnpInit();
	Sleep(200);

#if !defined(__CYGWIN__)
	int VPNcount = devP2Plib::VPNAdapterCount();
#endif
	devP2Plib::CVPNInterface *vpn = NULL;


	devP2Plib::CP2P *p1 = devP2Plib::CP2P::Create();

	p1->Events.DataReceived = p2p_DataReceived;
	p1->Events.FileDone = p2p_FileDone;
	p1->Events.FileProgress = p2p_FileProgress;
	p1->Events.FileReceive = p2p_FileReceive;
	p1->Events.FileSend = p2p_FileSend;
	p1->Events.LinkDone = p2p_LinkDone;
	p1->Events.NewUPNPMapping = p2p_NewUPNPMapping;
	p1->Events.SearchDone = p2p_SearchDone;
	p1->Events.SearchStart = p2p_SearchStart;
	p1->Events.StateChange = p2p_StateChange;
	p1->Events.TextReceived = p2p_TextReceived;
	p1->Events.Stopped = p2p_Stopped;
	p1->Events.ForwardOpen = p2p_ForwardOpen;
	p1->Events.ForwardClose = p2p_ForwardClose;
	p1->Events.UserConnected = p2p_UserConnected;
	p1->Events.UserDisconnected = p2p_UserDisconnected;

	int proto = 0;
	char linkaddr[8192] = {0};
	char sendfile[1024] = {0};
	char password[1024] = {0};
	char ip[128];
	memset(ip, 0, sizeof(ip));
	char netmask[128];
	memset(netmask, 0, sizeof(netmask));


	int i=1;
	while (i<argc)
	{
		if (*argv[i] == '-' || *argv[i]=='/')
		{
			char *a = argv[i];
			while (*a && (*a == '-' || *a == '/')) a++;

			if (!_stricmp(a, "mediatorip"))
			{
				i++;
				if (i < argc)
				{
					p1->MediatorAddress = argv[i];
					i++;
				}
			}
			else
			if (!_stricmp(a, "password"))
			{
				i++;
				if (i < argc)
				{
					strcpy(password, argv[i]);
					i++;
				}
			}
			else
			if (!_stricmp(a, "mediatorport"))
			{
				i++;
				if (i < argc)
				{
					p1->MediatorPort = atoi(argv[i]);
					i++;
				}
			}
			else
			if (!_stricmp(a, "udp"))
			{
				i++;
				proto |= devP2Plib::ProtoUDP;
				if (i < argc)
				{
					if (*argv[i] != '-' && *argv[i] != '/')
					{
						p1->UDPPort = atoi(argv[i]);
						i++;
					}
				}
			}
			else
			if (!_stricmp(a, "tcp"))
			{
				i++;
				proto |= devP2Plib::ProtoTCP;
				if (i < argc)
				{
					if (*argv[i] != '-' && *argv[i] != '/')
					{
						p1->TCPPort = atoi(argv[i]);
						i++;
					}
				}
			}
			else
			if (!_stricmp(a, "link"))
			{
				i++;
				if (i < argc)
				{
					char *ip = argv[i];
					char *sport = strchr(ip, ':');
					if (sport)
					{
						*sport = 0;
						sport++;
						char buff[128];
						sprintf(buff, "<TCP IP=\"%s\" Port=\"%s\"/>", ip, sport);
						strcat(linkaddr, buff);
					}
					i++;
				}
			}
			else
			if (!_stricmp(a, "relay"))
			{
				i++;
				if (i < argc)
				{
					char *ip = argv[i];
					char *sport = strchr(ip, ':');
					if (sport)
					{
						*sport = 0;
						sport++;
						char buff[128];
						sprintf(buff, "<TCP Type=\"Relay\" IP=\"%s\" Port=\"%s\"/>", ip, sport);
						strcat(linkaddr, buff);
					}
					i++;
				}
			}
			else
			if (!_stricmp(a, "send"))
			{
				i++;
				if (i < argc)
				{
					strcpy(sendfile, argv[i]);
					i++;
				}
			}
			else
#if !defined(__CYGWIN__)
			if (!_stricmp(a, "listadapters"))
			{
				i++;
				printf("---Local adapters available---\r\n");
				for (int j=0;j<VPNcount;j++)
				{
					devP2Plib::CVPNInterface *vpn = devP2Plib::VPNAdapter(j);
					struct in_addr ina1, ina2;
					ina1.s_addr = vpn->LocalIP;
					ina2.s_addr = vpn->LocalNetmask;
					printf("ID %d:  Name: %s  ", j, vpn->Name);
					printf("IP: %s  ", inet_ntoa(ina1));
					printf("Netmask: %s  ", inet_ntoa(ina2));
					char buf[19];
					memset(buf, 0, sizeof(buf));
					devP2Plib::MacToText(vpn->LocalMAC, buf);
					printf("Mac: %s\r\n", buf);
				}
				printf("---End of listing---\r\n");
			}
			else
				if (!_stricmp(a, "useadapter"))
				{
					i++;
					if (i < argc)
					{
						devP2Plib::CVPNInterface *vpn1 = NULL;
#if defined(__APPLE__) || defined(__FreeBSD__)
						vpn1 = devP2Plib::VPNAdapter(0);
						if (vpn1)
						{
							strcpy(vpn1->Name, argv[i]);
							vpn = vpn1;
						}
#else
						for (int j=0;j<VPNcount;j++)
						{
							vpn1 = devP2Plib::VPNAdapter(j);	
							if (vpn1 && !strcmp(vpn1->Name, argv[i]))
							{
								vpn = vpn1;
								break;
							}
						}
#endif
						if (!vpn)
							printf("WARNING: invalid adapter selected\r\n");

						i++;
					}
				}
				else
					if (!_stricmp(a, "setip"))
					{
						i++;
						strcpy(ip, argv[i]);
						i++;
					}
					else
						if (!_stricmp(a, "setnetmask"))
						{
							i++;
							strcpy(netmask, argv[i]);
							i++;
						}
#endif // ifdef cygwin
			else
				i++;
		}
		else
		{
			if (!p1->MyName)
				p1->MyName = argv[i];
			else
				if (!p1->PeerName)
					p1->PeerName = argv[i];

			i++;
		}
	}

	if (!p1->MyName || !p1->PeerName)
	{
		Usage();
		exit(-1);
	}

	if (vpn)
	{
		if (p1->SetAdapter(vpn) == devP2Plib::ErrorNone)
		{
			if (*ip)
				vpn->SetIP(ip, netmask);

			struct in_addr ina1;
			ina1.s_addr = vpn->LocalIP;
			printf("Using VPN adapter %s <%s>\r\n", vpn->Name, inet_ntoa(ina1));
		}
		else
			printf("WARNING: %s\r\n", p1->ErrorText(devP2Plib::ErrorCannotOpenAdapter));
	}

	if (!proto)
		proto = devP2Plib::ProtoBoth;

	if (*password)
		p1->SetPassword(devP2Plib::EncAES128, password);

	p1->RelayLicense = (char *)"anything";
	int success = p1->Start((devP2Plib::Protocols)proto);

	if (success >= 0)
	{
		success = p1->Search(NULL);
	}

	if (success >= 0)
	{
		if ((proto & devP2Plib::ProtoTCP) && *linkaddr)
			success = p1->Link(linkaddr);
	}

	if (success >= 0)
	{
		while (p1->State != devP2Plib::StateConnected) Sleep(100);
	}

	if (success >= 0)
	{
		if (*sendfile)
			p1->SendFile(1, sendfile);
	}

	if (success >= 0)
	{
		int key;
		bool cont = true;
		do 
		{
			key = getch();
			switch (key)
			{
			case 'x':
				cont = false;
				break;

			case 't':
				success = p1->SendText(200, (char *)"hello there", true);
				break;

			case 'd':
				success = p1->SendData(200, (char *)"howdy\0", 6, true);
				break;

			case 's':
				success = p1->SendFile(2, (char *)"data.bin");
				break;

			case 'p':
				{
					devP2Plib::CP2PForward *f = p1->GetForward(0);
					if (f)
					{
						f->ForwardType = devP2Plib::TCPSocksProxy;
						strcpy(f->LocalAddress, "127.0.0.1");
						f->LocalPort = 1080;
						success = p1->StartForward(0);
					}
				}
				break;

			case '1':
				{
					success=p1->TestBandwidth(4, 1024*1024*1);
				}
				break;

			case '2':
				{
					success=p1->TestBandwidth(4, 1024*1024*10);
				}
				break;

			case '3':
				{
					success=p1->TestBandwidth(4, 1024*1024*100);
				}
				break;

			case ' ':
				{
					p1->PrintStats();
				}
			break;

			}
			if (success < 0)
				printf("%s] Got error %d %s\r\n", p1->MyName, success, p1->ErrorText((devP2Plib::Errors)success));

		} while (cont);
	}
	if (success < 0)
		printf("%s] Got error %d %s\r\n", p1->MyName, success, p1->ErrorText((devP2Plib::Errors)success));

	p1->Disconnect();
	p1->Stop();
	p1->Destroy();
//	delete p1;

	devP2Plib::libFree();

#ifdef _WIN32
	WSACleanup();
#endif
	return 0;
}
